// EVA* ѥǥץ쥤ץ
//   ޤѥߤʤΡˤɽ
// UNIX ᤸʤС

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "lcdisp.h"

int mag=0;  // ߡ

MaskInfo::~MaskInfo()
{
	delete mask;
	delete next;
}

Display *d;
Window w;
GC gc;
unsigned long palette[16];
unsigned long maskpalette;

Pixmap OnPixmap=0;
Pixmap OffPixmap=0;

// ѤǽѥåȤˤ뤫
int PaletteChangeMask[16]={0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0};
//int PaletteChangeMask[16]={1,1,1,1, 1,1,1,1, 1,1,1,1, 1,1,1,1};

unsigned long MyRGBColor(unsigned short r,
			 unsigned short g,unsigned short b)
{
  Colormap cmap;
  XColor c0;

  cmap=DefaultColormap(d,0);
  c0.red=r;
  c0.green=g;
  c0.blue=b;
  XAllocColor(d,cmap,&c0);
  return(c0.pixel);
}

 
int InitializeGraphics(char *geometry)
{
  d=XOpenDisplay(NULL);
  if(d==NULL)
    {
	printf("cannot open DISPLAY\n");
	return -1;
    }
  XSetWindowAttributes xswa;
  unsigned long pl[3],px[8];

  int x,y,rx,ry;
  unsigned int dw,dh,mask,dbd,ddep;
  Window dwin;
  int rootwidth,rootheight;

  XGetGeometry(d,RootWindow(d,0),&dwin,&x,&y,&dw,&dh,&dbd,&ddep);
  rootwidth=dw;
  rootheight=dh;

  rx=0;
  ry=0;

  if(strcmp(geometry,"center")==0)
    {
	rx=(rootwidth-640)/2;
	ry=(rootheight-400)/2;
    }
  else if(geometry!=NULL)
    {
	mask=XParseGeometry(geometry,&x,&y,&dw,&dh);
	if(mask & XValue) rx=x;
	if(mask & YValue) ry=y;
	if(mask & XNegative) rx=rootwidth+rx-640;
	if(mask & YNegative) ry=rootheight-400+ry;
    }

  int i;
  for(i=0;i<16;i++)
    palette[i]=0;

  xswa.override_redirect=True;
    
  xswa.backing_store=Always;
  w=XCreateWindow(d,RootWindow(d,0),rx,ry,
		  640,400,0,CopyFromParent,InputOutput,CopyFromParent,
		  CWBackingStore,&xswa);

  maskpalette=pl[0];
  gc=XCreateGC(d,w,0,NULL);

  return 0;
}


void ChangePalette(int i,unsigned int r,unsigned int g,unsigned int b)
{
    if(PaletteChangeMask[i]==0) return;
    Colormap cm=DefaultColormap(d,0);
    XColor co;
    co.flags=DoRed|DoGreen|DoBlue;
    co.red=r*0x0101;
    co.green=g*0x0101;
    co.blue=b*0x0101;
    co.pixel=palette[i];
    XStoreColor(d,cm,&co);
}

void AllocatePalette(unsigned char *pal)
{
    Colormap cm=DefaultColormap(d,0);
    long pm,pl;
    int i;
    for(i=0;i<16;i++)
      {
	  if(PaletteChangeMask[i])
	    {
		if(XAllocColorCells(d,cm,False,&pm,0,&pl,1)==0)
		  {
		      palette[i]=MyRGBColor(pal[i*3+1]*0x101,pal[i*3+0]*0x101,
					    pal[i*3+2]*0x101);
		      printf("cannot get palette cell");
		      PaletteChangeMask[i]=0;
		  }
		else
		  {
		      palette[i]=pl;
		      ChangePalette(i,pal[i*3+1],pal[i*3+0],pal[i*3+2]);
		  }
	    }
	  else
	    palette[i]=MyRGBColor(pal[i*3+1]*0x101,pal[i*3+0]*0x101,
				  pal[i*3+2]*0x101);
      }
    return;
}

void Terminate(void)
{
    if(OnPixmap) XFreePixmap(d,OnPixmap);
    if(OffPixmap) XFreePixmap(d,OffPixmap);
}

// ============================================================
// ΰؿ

// ȹԤȤоݹԤĹ
int LineExtension(byte *ope,byte *src)
{
    int i; // ѥ
    int f; // Ĺե饰
    int fh=0; // ѹե饰
    // 
    f=0;
    for(i=0;i<639;i++)
      {
	  if((f==1) && (src[i]!=0) && (ope[i]==0))
	    {
		ope[i]=1;
		fh=1;
	    }
	  if(ope[i]) f=1;
	  else       f=0;
      }
    f=0;
    for(i=639;i>0;i--)
      {
	  if((f==1) && (src[i]!=0) && (ope[i]==0))
	    {
		ope[i]=1;
		fh=1;
	    }
	  if(ope[i]) f=1;
	  else       f=0;
      }

    return fh;
}

struct LineStack
{
	int line;
	int direction;
};

// 岼ؤγĥ
// ͡ĥʤäĥ
int UDExtension(byte *ope,byte *src,byte *last)
{
    int i;
    byte t;
    int f=0;
    int min,max;
    max=0;
    for(i=0;i<640;i++)
      {
	  if((src[i]!=0)&&(last[i]!=0))
	    {  // ŤʤäƤ
		max=i;
		if(ope[i]==0)
		  {
		      ope[i]=1;
		      f=1;
		  }
	    }
	  else if(max==0)
	    min=i;
      }
//    printf("%d %d\n",min,max);
    return f;
}

void PlaneExtension(byte *ope,byte *src,int startline)
{
    LineStack stack[50];
    int sp=0;
    
    // ǽ򥹥åѤ
    stack[sp].line=startline;
    stack[sp].direction=1;
    sp++;
    stack[sp].line=startline;
    stack[sp].direction=-1;
    sp++;
    
    int line;  // ι
    int r;
    // åν
    while(sp)
      {
	  sp--;
	  line=stack[sp].line;
	  if(stack[sp].direction>0)
	    {
		if(line>0)   // ־ιԤʤʤˤ⤤ʤ
		  {
		      r=UDExtension(ope+640*(line-1),src+640*(line-1),
				    ope+640*line);
		      if(r!=0) // ޤޤ夬餷
			{
			    //⤦ľ
			    stack[sp].line=line-1;
			    stack[sp].direction=1;
			    sp++;
			    if(LineExtension(ope+640*(line-1),src+640*(line-1)))
			      {    // ɬ᲼
				  stack[sp].line=line-1;
				  stack[sp].direction= -1;
				  sp++;
			      }
			}
		  }
	    }
	  else  // 
	    {
		if(line<399)   // ־ιԤʤʤˤ⤤ʤ
		  {
		      r=UDExtension(ope+640*(line+1),src+640*(line+1),
				    ope+640*line);
		      if(r!=0) // ޤޤ餷
			{
			    //⤦Ĳ
			    stack[sp].line=line+1;
			    stack[sp].direction=-1;
			    sp++;
			    if(LineExtension(ope+640*(line+1),src+640*(line+1)))
			      {    // ɬ
				  stack[sp].line=line+1;
				  stack[sp].direction= 1;
				  sp++;
			      }
			}
		  }
	    }
      }
}

// ========================================================
// ޥؿ
MaskInfo *BufferToMask(byte *bbuf)
{
    MaskInfo *r=new MaskInfo;
    int x,y,i;
    int sx,sy,ex,ey;
    
    sx=640;  sy=400;
    ex=0;    ey=0;
    for(x=0;x<640;x++)
      for(y=0;y<400;y++)
	if(bbuf[x+y*640])
	  {
	      if(x<sx) sx=x;
	      if(y<sy) sy=y;
	      if(x>ex) ex=x;
	      if(y>ey) ey=y;
	  }
    byte *buf=new byte [((ex-sx+8)/8)*(ey-sy+1)];
    if(buf==NULL)
      {
	  printf("cannot get memory \n");
	  return NULL;
      }

    XImage *image;
    image=XCreateImage(d,DefaultVisual(d,0),1,XYBitmap,
		       0,(char *)buf,(ex-sx+1),(ey-sy+1),8,0);

    for(y=sy; y<=ey; y++)
      for(x=sx; x<=ex; x++)
	{
	    XPutPixel(image,x-sx,y-sy,bbuf[x+y*640]);
	}

    // 
    r->mask=buf;
    r->x=sx;
    r->y=sy;
    r->sizex=(ex-sx+1);
    r->sizey=(ey-sy+1);
    r->size=(r->sizey)*(ex-sx+8)/8;
    free(image);
    return r;
}

void MaskSet(MaskInfo *m,int onoff)
{
    // ȡ
    Pixmap src=OffPixmap;
    if(onoff)
      src=OnPixmap;

    // ޤȴ
    XImage *image;
    image=XCreateImage(d,DefaultVisual(d,0),1,XYBitmap,
		       0,(char *)(m->mask),m->sizex,m->sizey,8,0);
//    Pixmap mask=XCreatePixmap(d,w,m->sizex,m->sizey,1);
    // Ϥߺ
    Pixmap pix=XCreatePixmap(d,w,m->sizex,m->sizey,DefaultDepth(d,0));
    Pixmap pix2=XCreatePixmap(d,w,m->sizex,m->sizey,DefaultDepth(d,0));
    XSetFunction(d,gc,GXcopy);
    XCopyArea(d,src,pix,gc,m->x,m->y,m->sizex,m->sizey,0,0);
    XCopyArea(d,w,pix2,gc,m->x,m->y,m->sizex,m->sizey,0,0);
    // ʤΤޤꥫå
    XSetForeground(d,gc,0xff);
    XSetBackground(d,gc,0);
    XSetFunction(d,gc,GXand);
    XPutImage(d,pix,gc,image,0,0,0,0,m->sizex,m->sizey);

    // ԡޤȤ̤
    XSetForeground(d,gc,0);
    XSetBackground(d,gc,0xff);
    XSetFunction(d,gc,GXand);
    XPutImage(d,pix2,gc,image,0,0,0,0,m->sizex,m->sizey);
    //
    XSetFunction(d,gc,GXor);
    XCopyArea(d,pix,pix2,gc,0,0,m->sizex,m->sizey,0,0);
    XSetFunction(d,gc,GXcopy);
    XCopyArea(d,pix2,w,gc,0,0,m->sizex,m->sizey,m->x,m->y);
//    XCopyArea(d,src,w,gc,m->x,m->y,m->sizex,m->sizey,m->x,m->y);
    XFreePixmap(d,pix);
    XFreePixmap(d,pix2);
    free(image);
}

void MaskOn(MaskInfo *m)
{
    MaskSet(m,1);
}
void MaskOff(MaskInfo *m)
{
    MaskSet(m,0);
}


// 
void MaskOnByNumber(MaskInfo *chain,int num)
{
    while(chain)
      {
	  if(chain->number==num) MaskOn(chain);
	  chain=chain->next;
      }
}

void MaskOffByNumber(MaskInfo *chain,int num)
{
    while(chain)
      {
	  if(chain->number==num) MaskOff(chain);
	  chain=chain->next;
      }
}

void MaskAllOff(MaskInfo *chain)
{
    while(chain)
      {
	  MaskOff(chain);
	  chain=chain->next;
      }
}

//  ޥΥեɡ
int SaveMask(MaskInfo *chain,char *filename)
{
    FILE *fp;
    if(chain==NULL) return 0;
    fp=fopen(filename,"wb");
    if(fp==NULL)
      {
	  printf("File '%s' cannot open as write\n",filename);
	  return -1;
      }
    while(chain)
      {
	  if(chain->mask!=NULL)
	    {
		fwrite(chain,sizeof(MaskInfo),1,fp);
		fwrite(chain->mask,sizeof(byte),chain->size,fp);
		chain=chain->next;
	    }
      }
    fclose(fp);
    return 0;
}

MaskInfo *LoadMask(char *filename)
{
    FILE *fp;
    fp=fopen(filename,"rb");
    if(fp==NULL)
      {
	  printf("File '%s' cannot open as read\n",filename);
	  return NULL;
      }
    MaskInfo *ch=NULL,*p=NULL;
    while(1)
      {
	  p=new MaskInfo;
	  if(p==NULL)
	    {
		delete ch;
		return NULL;
	    }
	  
	  fread(p,sizeof(MaskInfo),1,fp);
	  p->mask=new byte[p->size];
	  if(p->mask==NULL)
	    {
		delete ch;
		return NULL;
	    }
	  fread(p->mask,sizeof(byte),p->size,fp);
	  if(p->next!=NULL)
	    {
		p->next=ch;
		ch=p;
	    }
	  else   // 
	    {
		p->next=ch;
		ch=p;
		break;
	    }
      }
    fclose(fp);
    return ch;
}


typedef unsigned char byte;
typedef unsigned short word;
typedef unsigned long dword;
extern int MagLoad(byte *&source, byte *&palette,
	    char *filename,int &sizex,int &sizey,
	    char *&user, char *&comment,int &mode);

// MAG ɤ߹ߤɽ
unsigned char *MagDisp(char *filename)
{
    int x,y,i,col,sizex,sizey;
    int pointc[256];
    XImage *image;
    unsigned char *imgbuff;

    unsigned char *pixel;
    unsigned char *pal;
    int pix;
    char *user,*comment;
    int mode;

/*    int mag_load(source,palette,filename,sizex,sizey,user,comment,mode);*/

    if(MagLoad(pixel,pal,filename,sizex,sizey,user,comment,mode)
       !=0)
      {
	  printf("cannot load file '%s'\n",filename);
	  return NULL;
      }
    
    if(mode != 0)
      {
	  printf("this system does not support 256 MAG \n");
	  return NULL;
      }
    sizex *= 4;
    if((sizex!=640)||(sizey!=400))
      {
	  printf("this system does not support %dx%d\n",sizex,sizey);
	  return NULL;
      }

//    puts("now drawing");
//    printf("User:%s\nComment:%s\n",user,comment);

    AllocatePalette(pal);

    char wname[200];
//    sprintf(wname,"LCDISP",filename);
//    XStoreName(d,w,wname);
    XStoreName(d,w,"LCDISP");
    XMapWindow(d,w);
    XFlush(d);

    imgbuff=(byte *)malloc(sizex*sizey*DefaultDepth(d,0)/8);
    if(imgbuff==NULL)
      {
	  fprintf(stderr,"cannot alloc memory\n");
	  exit(0);
      }
    image=XCreateImage(d,DefaultVisual(d,0),DefaultDepth(d,0),ZPixmap,0,(char *)imgbuff,640,400,8,0);
    
    /* image expansion */
    XSetFunction(d,gc,GXcopy);
    OnPixmap=XCreatePixmap(d,w,sizex,sizey,DefaultDepth(d,0));
    OffPixmap=XCreatePixmap(d,w,sizex,sizey,DefaultDepth(d,0));
    for(y=0;y<400;y++)
      {
	  for(x=0;x<640;x++)
	    {
		if((x & 1)==0)
		  col = (pixel[(y*640+x)/2] >> 4)&0xf;
		else
		  col = pixel[(y*640+x)/2] & 0xf;
		XPutPixel(image,x,y,palette[col]);
	    }
      }
    XPutImage(d,w,gc,image,0,0,0,0,sizex,sizey);
    // Pixmap 
    XPutImage(d,OnPixmap,gc,image,0,0,0,0,sizex,sizey);
    for(y=0;y<400;y++)
      {
	  for(x=0;x<640;x++)
	    {
		if((x & 1)==0)
		  col = (pixel[(y*640+x)/2] >> 4)&0x7;
		else
		  col = pixel[(y*640+x)/2] & 0x7;
		XPutPixel(image,x,y,palette[col]);
	    }
      }
    XPutImage(d,OffPixmap,gc,image,0,0,0,0,sizex,sizey);
    XFlush(d);
    XDestroyImage(image);
    free(imgbuff);
    return pixel;
}


// ޥСɸޥѥɥץ졼󤫤
MaskInfo *InitializeMask(char *filename,char *geometry)
{
    byte *src;      // ɥץ졼Υԡ
    byte *dest;     // 
    byte *pixel;

    char magfile[200];
    char hspfile[200];
    char mskfile[200];
    
    strcpy(magfile,filename);
    strcat(magfile,".mag");
    strcpy(hspfile,filename);
    strcat(hspfile,".hsp");
    strcpy(mskfile,filename);
    strcat(mskfile,".msk");
    
    if(InitializeGraphics(geometry)<0)
      return NULL;
    printf("Now, Loading and Processing.\n");
    // MAG File ɤ߹

    if((pixel=MagDisp(magfile))==NULL)
      {
	  printf("ǡեɤ߹ߤ˼Ԥޤ\n");
	  return NULL;
      }
    // ޥեγǧ
    
    MaskInfo *chain=NULL;
    chain=LoadMask(mskfile);
    if(chain!=NULL)
      {
	  MaskAllOff(chain);
	  return chain;
      }
    printf("mask ե뤬̵Τޤ\n");
    
    FILE *fp;
    fp=fopen(hspfile,"r");
    if(fp==NULL)
      {
	  printf("cannot open '%s'",hspfile);
	  return NULL;
      }
    
    src=new byte [640*400];
    dest=new byte [640*400];
    if(dest==NULL)
      {
	  printf("cannot allocate memory\n");
	  exit(-1);
      }
    // ɥץ졼Υԡ
    int x,y,col;
    for(x=0;x<640;x++)
      for(y=0;y<400;y++)
	{
 	    if((x & 1)==0)
	      col = pixel[(y*640+x)/2] >> 4;
	    else
	      col = pixel[(y*640+x)/2] & 0xf;
	    if(col & 0x8)
	      src[x+y*640]=1;
	    else
	      src[x+y*640]=0;
	}
    
    char buff[200];
    int n;
    while(!feof(fp))
      {
	  if(fgets(buff,190,fp)==NULL) break;
	  if(sscanf(buff,"%d %d %d",&n,&x,&y)!=3) continue;
	  if((x<0) || (x>639) || (y<0) || ( y>399)) continue;
//		printf("%d: (%d,%d)\n",n,x,y);
	  
	  memset(dest,0,640*400);
	  
	  byte *s,*o;
	  s=src+(y*640);
	  o=dest+(y*640);
	  o[x]=1;
	  LineExtension(o,s);
	  PlaneExtension(dest,src,y);
	  MaskInfo *r=BufferToMask(dest);
	  if(r==NULL)
	    break;
	  r->number=n;
	  r->next=chain;
	  chain=r;
      }
    fclose(fp);
    delete src;
    delete dest;
    SaveMask(chain,mskfile);
    MaskAllOff(chain);
    printf("ޥλ\n");
    return chain;
}



// ޤ
int GetWinButton(void)
{
    Window r,c;
    int rx,ry;
    int wx,wy;
    unsigned int mask;
    if(XQueryPointer(d,w,&r,&c,&rx,&ry,&wx,&wy,&mask)!=True)
      return 0;
    if((wx<0) || (wy<0) || (wx>640) || (wy>400)) return 0;  

    if(mask & Button1Mask)
      return 'i';
    if(mask & Button2Mask)
      return 'e';
    if(mask & Button3Mask)
      return 'q';
    return 0;
}
