// EVA power timer ɽץ

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/time.h>
#include "lcdisp.h"

// setitimer λѤ
// ȥȤ setitimer  gettimeofday
// #define USEITIMER

//extern "C" 
//int setitimer(int which, struct itimerval *val,struct itimerval *oval);

// ޡ
int counter=0;
int timer_mode=0;


#ifdef USEITIMER
long timer=88888l;

static void timer_func(int)
{
    signal(SIGALRM,timer_func);
    struct itimerval it,ot;
    it.it_interval.tv_sec=0;
    it.it_interval.tv_usec=0;
    it.it_value.tv_sec=0;
    it.it_value.tv_usec=10000;
    setitimer(ITIMER_REAL,&it,&ot);
    counter++;
    if(timer==0)    // ޡäƤ
      return;
    if(timer_mode==0)  // ޡɬפȤƤʤ
      return;
    timer--;
}

inline int gettimer(void)
{
    return timer;
}

inline void settimer(int tm)
{
    timer=tm;
}

int delay(int length)   // ߴ롼: msec Ԥ
{
    int a;
    length /= 10;
    int st=counter;
    while(counter<st+length)
      a++;  // ߡ
    return a;
}

#else       // USEITIMER
unsigned long tm_last_10msec;
int timer=88888;

inline int gettimer(void)
{
    struct timeval tp;
    unsigned long tm_10msec;
   
    gettimeofday(&tp,NULL);    // ֤μ
    tm_10msec=tp.tv_sec*100+tp.tv_usec/10000;   // ȥХ롣
    // ǯˣ٤餤

    if(timer_mode)  // ž
      {
	  timer-=(tm_10msec-tm_last_10msec);
	  tm_last_10msec=tm_10msec;
	  if(timer<0)
	    timer=0;
	  return timer;
      }
    else    // 
      {
	  tm_last_10msec=tm_10msec;
	  return timer;
      }
}

inline void settimer(int tm)
{
    timer=tm;
}

void delay(int length)
{
    struct timeval tp,tp_start;
    gettimeofday(&tp_start,NULL);    // ֤μ
    while(1)
      {
	  gettimeofday(&tp,NULL);    // ֤μ
	  if(((tp.tv_sec-tp_start.tv_sec)*1000+
	      (tp.tv_usec-tp_start.tv_usec)/1000)>length)
	    break;
      }
}

#endif      // USEITIMER

const int Masks=42;
//  ޥֹбɽ
const int MaskRec[Masks]=
{
    101,102,103,104,105,106,107,
    201,202,203,204,205,206,207,
    301,302,303,304,305,306,307,
    401,402,403,404,405,406,407,
    501,502,503,504,505,506,507,
    1,2,5,6,7,8,9
};

enum
{
    M_Internal=35,
    M_External,
    M_Stop,
    M_Slow,
    M_Normal,
    M_Racing,
    M_Danger,
};


//  ޥξִ
int MaskOnOff[Masks]=
{
    0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,
    0,0
};
// ѹ׵
int MaskRequest[Masks]=
{
    0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,
    0,0
};


// ޥѹ׵μ¹
void ChangeMask(MaskInfo *chain)
{
    int i;
    for(i=0;i<Masks;i++)
      {
	  if(MaskOnOff[i]!=MaskRequest[i])
	    {
		MaskOnOff[i]=MaskRequest[i];
		if(MaskOnOff[i])
		  MaskOnByNumber(chain,MaskRec[i]);
		else
		  MaskOffByNumber(chain,MaskRec[i]);
	    }
      }
}

// 7seg ѥ
const int digit_pat[10]=
{
//    0    1    2    3    4    5    6    7    8    9
    0x3f,0x06,0x5b,0x4f,0x66,0x6d,0x7d,0x27,0x7f,0x6f
};

void SetDigit(int digit,int count)
{
    int i;
    byte t=1;
    for(i=0;i<7;i++)
      {
	  if(t & digit_pat[count])
	    MaskRequest[digit*7+i]=1;
	  else
	    MaskRequest[digit*7+i]=0;
	  t=t<<1;
      }
}

void DispTime(long time)
{
    int i;
    if(time<10000)
      ChangePalette(9,0xff,0x66,0x0);
    else
      ChangePalette(9,0xff,0x88,0x0);
    for(i=0;i<5;i++)
      {
	  SetDigit(4-i,time % 10);
	  time /=10;
      }
}

void SetTime(void)
{
    int m,s,ss;
    int times=gettimer();
    ss=times % 100;
    m=times/6000;
    s=(times/100)%60;

    DispTime(m*10000l+s*100+ss);
}


void inline ExternalMode(void)
{
    MaskRequest[M_External]=1;
    MaskRequest[M_Internal]=0;
    MaskRequest[M_Normal]=1;
    MaskRequest[M_Racing]=0;
    MaskRequest[M_Stop]=0;
    MaskRequest[M_Slow]=0;
    MaskRequest[M_Danger]=0;
    
    timer_mode=0;  // ޡ

    DispTime(88888l);
}

void inline InternalMode(void)
{
    MaskRequest[M_External]=0;
    MaskRequest[M_Internal]=1;
    MaskRequest[M_Normal]=0;
    MaskRequest[M_Racing]=1;
    MaskRequest[M_Stop]=0;
    MaskRequest[M_Slow]=0;
    MaskRequest[M_Danger]=0;
    
    SetTime();
}

void inline DeclimentTime(void)
{
    SetTime();
    if(gettimer()<6000l)
      MaskRequest[M_Danger]=1;
}


int main(int argc,char **argv)
{
    long timer_length=0l;   	// ޡν
    int internal=0;             // ζ
    int i,autostart=0;
    char c;
    char *command;
    char *geometry;
    char *viewfile="evatimer";

    command=NULL;
    geometry="+0+0";
    // ưץΥå
    for(i=1;i<argc;i++)
      {
	  if((strcmp(argv[i],"-limit")==0) && (i<argc-1))
	    {
		timer_length=atoi(argv[i+1])*100l;
	    }
	  if((strcmp(argv[i],"-exec")==0) && (i<argc-1))
	    {
		command=argv[i+1];
	    }
	  if((strcmp(argv[i],"-geometry")==0) && (i<argc-1))
	    {
		geometry=argv[i+1];
	    }
	  if(strcmp(argv[i],"-auto")==0)
	    autostart=1;
	  if(strcmp(argv[i],"-real")==0)
	    viewfile="evtmreal";
	  if(strcmp(argv[i],"-double")==0)
	    mag=2;
      }

    PaletteChangeMask[9]=1;
    MaskInfo *chain=InitializeMask(viewfile,geometry);
    if(chain==NULL)
      return 1;
    

    if(timer_length>59999l) timer_length=59999l;
    if(timer_length==0)
      timer_length=5*6000l;

#ifdef USEITIMER    
    // SIGALRM Τä;
    struct itimerval it,ot;
    it.it_interval.tv_sec=0;
    it.it_interval.tv_usec=0;
    it.it_value.tv_sec=0;
    it.it_value.tv_usec=10000;
    signal(SIGALRM,timer_func);
    setitimer(ITIMER_REAL,&it,&ot);
#endif // USEITIMER

    ExternalMode();
    ChangeMask(chain);
    while(1)
      {
	  c=GetWinButton();
	  if(c=='q') break;
	  if(((c=='i') || (autostart==1)) && (internal==0))
	    {
		settimer(timer_length);
		InternalMode();
		internal=1;
		ChangeMask(chain);
		ExternalMode();   delay(10);
		ChangeMask(chain);
		InternalMode();   delay(10);
		ChangeMask(chain);                  // Ĥ
		timer_mode=1;
		delay(350);
	    }
	  if((c=='e') && (internal==1))
	    {
		timer_mode=0;
		ExternalMode();
		ChangeMask(chain);
		InternalMode();    delay(10);
		ChangeMask(chain);
		ExternalMode();    delay(10);
		ChangeMask(chain);  // Ĥ
		      
		internal=0;
	    }

	  if(internal==1)
	    {
		DeclimentTime();
		if(gettimer()==0)
		  {
		      MaskRequest[M_Racing]=0;
		      MaskRequest[M_Stop]=1;
		      SetTime();
		      ChangeMask(chain);
/*		      if((off==1) && (note==1))
			{
			    _AH=0x98;
			    geninterrupt(0x1f);  // Ÿ
			}*/
		      // ޥɼ¹
		      if(command!=NULL)
			{
			    signal(SIGALRM,SIG_IGN);
			    system(command);
			    return 0;
			}
		      if(autostart==1) 
			return 0;
		  }
		ChangeMask(chain);
	    }
      }
#ifdef USEITIMER
    signal(SIGALRM,SIG_IGN);
#endif
    Terminate();
    
    return 0;
}
